OGRE-Next: Ogre::SubItem Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::SubItem Class Reference
Core | Component » Scene

Utility class which defines the sub-parts of an Item. More...

`#include <OgreSubItem.h>`

Inheritance diagram for Ogre::SubItem:
[legend]

## Public Member Functions
| ~SubItem () override
| Destructor.
void | _setHlmsHashes (uint32 hash, uint32 casterHash) override
| Manually sets the hlms hashes. Don't call this directly.
void | addPoseWeight (const Ogre::String &poseName, float w)
void | addPoseWeight (size_t index, float w)
bool | getCastsShadows () const override
| Method which reports whether this renderable would normally cast a shadow.
const LightList & | getLights () const override
| Gets a list of lights, ordered relative to how close they are to this renderable.
Item * | getParent () const
| Accessor to get parent Item.
float | getPoseWeight (const Ogre::String &poseName) const
float | getPoseWeight (size_t index) const
void | getRenderOperation (v1::RenderOperation &op, bool casterPass) override
| Gets the render operation required to send this object to the frame buffer.
SubMesh * | getSubMesh () const
| Accessor method to read mesh data.
void | getWorldTransforms (Matrix4 *xform) const override
| Gets the world transform matrix / matrices for this renderable object.
void | setPoseWeight (const Ogre::String &poseName, float w)
void | setPoseWeight (size_t index, float w)
Public Member Functions inherited from Ogre::RenderableAnimated
| RenderableAnimated ()
const IndexMap * | getBlendIndexToBoneIndexMap () const
Public Member Functions inherited from Ogre::Renderable
| Renderable ()
virtual | ~Renderable ()
| Virtual destructor needed as class has virtual methods.
virtual void | _setNullDatablock ()
| Sets the datablock to a null pointer.
virtual void | _updateCustomGpuParameter (const GpuProgramParameters_AutoConstantEntry &constantEntry, GpuProgramParameters *params) const
| Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows.
void | addPoseWeight (size_t index, float w)
uint8 | getCurrentMaterialLod () const
const Vector4 & | getCustomParameter (size_t index) const
| Gets the custom value associated with this Renderable at the given index.
const CustomParameterMap & | getCustomParameters () const
HlmsDatablock * | getDatablock () const
const String & | getDatablockOrMaterialName () const
uint32 | getHlmsCasterHash () const
uint32 | getHlmsHash () const
MaterialPtr | getMaterial () const
| Retrieves the material this renderable object uses.
unsigned short | getNumPoses () const
virtual unsigned short | getNumWorldTransforms () const
| Returns the number of world transform matrices this renderable requires.
virtual bool | getPolygonModeOverrideable () const
| Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
bool | getPoseHalfPrecision () const
bool | getPoseNormals () const
TexBufferPacked * | getPoseTexBuffer () const
float | getPoseWeight (size_t index) const
float * | getPoseWeights () const
uint8 | getRenderQueueSubGroup () const
bool | getUseIdentityProjection () const
| Returns whether or not to use an 'identity' projection.
bool | getUseIdentityView () const
| Returns whether or not to use an 'identity' view.
virtual bool | getUseIdentityViewProjMatrixIsDynamic () const
| Returns whether the Hlms implementation should evaluate getUseIdentityProjection per object at runtime, or if it can assume the Renderable will remain with the same setting until the datablock is flushed (performance optimization).
virtual bool | getUseIdentityWorldMatrix () const
| Returns whether the world matrix is an identity matrix.
virtual OGRE_DEPRECATED const Any & | getUserAny () const
UserObjectBindings & | getUserObjectBindings ()
| Return an instance of user objects binding associated with this class.
const UserObjectBindings & | getUserObjectBindings () const
| Return an instance of user objects binding associated with this class.
const VertexArrayObjectArray & | getVaos (VertexPass vertexPass) const
bool | hasCustomParameter (size_t index) const
| Checks whether a custom value is associated with this Renderable at the given index.
bool | hasSkeletonAnimation () const
virtual void | postRender (SceneManager *sm, RenderSystem *rsys)
| Called immediately after the Renderable has been rendered.
virtual bool | preRender (SceneManager *sm, RenderSystem *rsys)
| Called just prior to the Renderable being rendered.
void | removeCustomParameter (size_t index)
| Removes a custom value which is associated with this Renderable at the given index.
void | setCustomParameter (size_t index, const Vector4 &value)
| Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters.
virtual void | setDatablock (HlmsDatablock *datablock)
| Assigns a datablock (i.e. HLMS Material) to this renderable.
void | setDatablock (IdString datablockName)
| Assigns a datablock (i.e.
void | setDatablockOrMaterialName (String materialName, String groupName)
| First tries to see if an HLMS datablock exist with the given name, if not, tries to search among low level materials.
virtual void | setMaterial (const MaterialPtr &material)
| Sets the given material. Overrides HLMS materials.
void | setMaterialName (const String &name, const String &groupName)
| Sets the name of the Material to be used. Prefer using HLMS.
virtual void | setPolygonModeOverrideable (bool override)
| Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
void | setPoseWeight (size_t index, float w)
void | setRenderQueueSubGroup (uint8 subGroup)
| Sets the render queue sub group.
void | setUseIdentityProjection (bool useIdentityProjection)
| Sets whether or not to use an 'identity' projection.
void | setUseIdentityView (bool useIdentityView)
| Sets whether or not to use an 'identity' view.
virtual OGRE_DEPRECATED void | setUserAny (const Any &anything)

## Additional Inherited Members
Public Types inherited from Ogre::RenderableAnimated
typedef FastArray< unsigned short > | IndexMap
Public Types inherited from Ogre::Renderable
typedef map< size_t, Vector4 >::type | CustomParameterMap
Static Public Member Functions inherited from Ogre::Renderable
static uint8 | getDefaultRenderQueueSubGroup ()
static void | setDefaultRenderQueueSubGroup (uint8 subGroup)
| Sets the default render queue sub group for all future Renderable instances.
Public Attributes inherited from Ogre::Renderable
uint8 | mCustomParameter
uint32 | mHlmsGlobalIndex
| Index in the vector holding this Rendrable reference in the HLMS datablock.
bool | mRenderableVisible
| Control visibility at Renderable (e.g.

## Detailed Description

Utility class which defines the sub-parts of an Item.

Remarks
  Just as meshes are split into submeshes, an Item is made up of potentially multiple SubMeshes. These are mainly here to provide the link between the Material which the SubItem uses (which may be the default Material for the SubMesh or may have been changed for this object) and the SubMesh data.

  The SubItem also allows the application some flexibility in the material properties for this section of a particular instance of this Mesh, e.g. tinting the windows on a car model.

  SubItem instances are never created manually. They are created at the same time as their parent Item by the SceneManager method createItem.

## Constructor & Destructor Documentation

## ◆ ~SubItem()

Ogre::SubItem::~SubItem | ( |  | ) |
| override

Destructor.

References Item.

## Member Function Documentation

## ◆ _setHlmsHashes()

void Ogre::SubItem::_setHlmsHashes | ( | uint32 | hash,
|  | uint32 | casterHash )
| overridevirtual

Manually sets the hlms hashes. Don't call this directly.

Reimplemented from Ogre::Renderable.

## ◆ addPoseWeight() [1/2]

void Ogre::SubItem::addPoseWeight | ( | const Ogre::String & | poseName,
|  | float | w )

## ◆ addPoseWeight() [2/2]

void Ogre::Renderable::addPoseWeight | ( | size_t | index,
|  | float | w )

## ◆ getCastsShadows()

bool Ogre::SubItem::getCastsShadows | ( |  | ) | const
| overridevirtual

Method which reports whether this renderable would normally cast a shadow.

Remarks
  Subclasses should override this if they could have been used to generate a shadow.

Reimplemented from Ogre::Renderable.

References Ogre::Renderable::addPoseWeight(), Ogre::Renderable::getPoseWeight(), and Ogre::Renderable::setPoseWeight().

## ◆ getLights()

const LightList & Ogre::SubItem::getLights | ( |  | ) | const
| overridevirtual

Gets a list of lights, ordered relative to how close they are to this renderable.

Remarks
  Directional lights, which have no position, will always be first on this list.

Implements Ogre::Renderable.

## ◆ getParent()

Item * Ogre::SubItem::getParent | ( |  | ) | const
| inline

Accessor to get parent Item.

References Item.

## ◆ getPoseWeight() [1/2]

float Ogre::SubItem::getPoseWeight | ( | const Ogre::String & | poseName | ) | const

## ◆ getPoseWeight() [2/2]

float Ogre::Renderable::getPoseWeight | ( | size_t | index | ) | const

## ◆ getRenderOperation()

void Ogre::SubItem::getRenderOperation | ( | v1::RenderOperation & | op,
|  | bool | casterPass )
| overridevirtual

Gets the render operation required to send this object to the frame buffer.

Implements Ogre::Renderable.

## ◆ getSubMesh()

SubMesh * Ogre::SubItem::getSubMesh | ( |  | ) | const

Accessor method to read mesh data.

## ◆ getWorldTransforms()

void Ogre::SubItem::getWorldTransforms | ( | Matrix4 * | xform | ) | const
| overridevirtual

Gets the world transform matrix / matrices for this renderable object.

Remarks
  If the object has any derived transforms, these are expected to be up to date as long as all the SceneNode structures have been updated before this is called.

  This method will populate transform with 1 matrix if it does not use vertex blending. If it does use vertex blending it will fill the passed in pointer with an array of matrices, the length being the value returned from getNumWorldTransforms.

Note
  Internal Ogre never supports non-affine matrix for world transform matrix/matrices, the behavior is undefined if returns non-affine matrix here.

See also
  Matrix4::isAffine.

Implements Ogre::Renderable.

## ◆ setPoseWeight() [1/2]

void Ogre::SubItem::setPoseWeight | ( | const Ogre::String & | poseName,
|  | float | w )

## ◆ setPoseWeight() [2/2]

void Ogre::Renderable::setPoseWeight | ( | size_t | index,
|  | float | w )

The documentation for this class was generated from the following file:

- OgreSubItem.h